<?php

/*
Plugin Name: Easy Custom Event Tickets
Description: Custom block Event Tickets RSVP, ajout liste des participants,
Author: BLADOU Alain
Version: 1.8
Author URI: https://rouerguecreation.fr/
License:GPL v2
License URI: http://www.gnu.org/licenses/gpl-2.0.txt
Text Domain: custom-event-tickets
Domain Path: /languages
*/




/***********************************************************************************************************
*
*  Easy Custom Event Tickets [REV:1.6] 

*  1. On charge le fichier de traduction
*  2. On inclut les fichiers relatif a la page de réglages du plugin
*  3. Actions a réaliser si l'utilisateur choisi d'initialiser les paramètres du plugin
*  4. Actions a réaliser à l'activation du Plugin
*  4.1  Actions a réaliser aprés la mise à jour du plugin
*  5. Uninstall Plugin
*  6. Chargement feuille de style du plugin
*  7. Afficher le nom des participants & nbr de réservation par participant aprés le ticket RSVP
*  7.1 CSS dynamique de la table des participants & du block Gutenberg RSVP
*  8. Afficher le nom des participants & nbr de réservation par participant aprés le bloc Tickets
*  8.1 CSS dynamique de la table des participants pour des billets payants
*  9. Afficher sur le calendrier des évènements en vue Liste le nbr de participant & nbr de billet restant pour des billets RSVP
*  10. Afficher sur le calendrier des évènements en vue Liste le nbr de participant & nbr de billet restant pour des billets payants
* 
*************************************************************************************************************/



/* Empêche l'utilisateur public d'accéder directement aux fichiers .php via l'URL
et garantit que les fichiers du plugin seront exécutés uniquement dans l'environnement WordPress.*/
defined( 'ABSPATH' ) || die();


define( 'ECET_EASY_CUSTOM_EVENTS_TICKETS_URL', plugin_dir_url( __FILE__ ) );

// plugin_basename( __FILE__ ) donne le chemin relatif du fichier principal du plugin 
// par rapport au répertoire plugins de WordPress et sans le  slash de début et de fin soit:
// custom_event_tickets/easy-custom-event-tickets.php
define( 'ECET_PLUGIN_PATH_NAME', plugin_basename( __FILE__ ) );


/*----------------------------------------------------------------------------*
 *           1. On charge le fichier de traduction
 *----------------------------------------------------------------------------*/

add_action( 'init', 'ecet_settings_load_textdomain' );

/* On charge le fichier de traduction .mo,  ECET_PLUGIN_PATH_NAME ==> custom-event-tickets/easy-custom-event-tickets.php
   Paramètres:  le domaine , Obsolète par défaut false,a partir du réperoire plugins de WordPress Chemin relatif vers le répertoire de langue où réside le fichier .mo : easy-custom-event-tickets/languages */
function ecet_settings_load_textdomain() {
    load_plugin_textdomain( 'custom-event-tickets', FALSE, dirname( ECET_PLUGIN_PATH_NAME ) . '/languages' );
}


/*----------------------------------------------------------------------------*
 *     2. On inclut les fichiers relatif a la page de réglages du plugin
 *----------------------------------------------------------------------------*/

include 'inc/admin-menu.php';
include 'inc/multiple-settings.php';


/*---------------------------------------------------------------------------------------------------*
 *           3. Actions a réaliser si l'utilisateur choisi d'initialiser les paramètres du plugin
 *--------------------------------------------------------------------------------------------------*/


add_action("admin_init", function () {
	
	/* 
	 On récupère les réglages du plugin sous forme d'un tableau avec pour index:
	ecet_radio_default_setting_field: initialiser le plugin aux paramètres par défaut
	ecet_radio_default_language_field: choix de la langue par défaut pour styliser le bloc gutenberg RSVP
	ecet_text_field: pour le titre de la table des participants
	ecet_select_title_tag_field : pour la balise HTML du titre
	ecet_select_column_field:  pour les nombre de colonne choisis pour la table des participants
	ecet_color_line_field:  couleur de fond des lignes paires
	ecet_select_border_width_field : épaisseur bordure table
	ecet_color_border_field: couleur bordure
	ecet_font_size_field: taille police
	ecet_font_color_field: couleur police
	ecet_rsvp_button_text_field: pour le texte affiché sur le bouton du Block Gutenberg RSVP
	ecet_text_below_number_of_participants_text_field: pour le texte affiché en dessous du nbr de participant sur le block Gutenberg RSVP
	ecet_closed_reservation_text_field: pour le texte affiché RÉSERVATION CLÔTURÉ sur le block Gutenberg RSVP
	ecet_form_reservation_textarea_field: pour le texte affiché en intro du formulaire de réservation
	ecet_event_number_participants_text_field: pour le texte affiché en préfixe du nombre de participants pour le calendrier des évènements en vue liste
	ecet_event_remaining_tickets_text_field: pour le texte affiché en préfixe du nombre de billets restant pour le calendrier des évènements en vue liste
	*/
	$settings  = get_option( 'ecet_multiple_setting' );
	
	/*if ( empty( $settings ) ) {
		
	   //Paramètres :  option_name , option_value , Description (plus utilisé) , Autoload(charger l'option au démarrage de WordPress)
	   update_option( 'ecet_multiple_setting', $settings, '', 'yes' );
	   exit;
	   
	}*/
	
	
	// L'utilisateur a choisi sur la page de réglages d'initialiser les valeurs 
	// de réglages par défaut du plugin
	if ($settings['ecet_radio_default_setting_field'] == 'yes') {
	
		// Attention! le champ radio ne prend pas de valeur avec majuscule
		$settings['ecet_radio_default_setting_field'] = 'no';
		//$settings['ecet_radio_default_language_field'] ='french';
		$settings['ecet_text_field'] = 'List of participants';
		$settings['ecet_select_title_tag_field'] = 'h3';
		$settings['ecet_select_column_field'] = '4';
		$settings['ecet_color_line_field'] = '#EFF8FE';
		$settings['ecet_select_border_width_field'] = '1';
		$settings['ecet_color_border_field'] = '#e4e4e4';
		$settings['ecet_select_font_size_field'] = '18';
		$settings['ecet_font_color_field'] = '#1E2226';
		$settings['ecet_rsvp_button_text_field'] = 'BOOKING';
		$settings['ecet_text_below_number_of_participants_text_field'] = 'Booking';
		$settings['ecet_closed_reservation_text_field'] = 'BOOKING CLOSED';
		$settings['ecet_form_reservation_textarea_field'] = 'Please submit your BOOKING information, including the total number of guests.';
		$settings['ecet_event_number_participants_text_field'] = 'number of participants:';
		$settings['ecet_event_remaining_tickets_text_field'] = 'remaining tickets:';
		
		//Paramètres :  option_name , option_value , Description (plus utilisé) , Autoload(charger l'option au démarrage de WordPress)
	    update_option( 'ecet_multiple_setting', $settings, '', 'yes' );
		
	}
	
});


/*----------------------------------------------------------------------------*
 *           4. Actions a réaliser à l'activation du Plugin
 *----------------------------------------------------------------------------*/
 

/* A l'activation du plugin on ajoute dans la table wp_options pour le champ option_name = ecet_multiple_setting 
  les réglages par défaut du plugin sous forme d'un tableau avec pour index:
   ecet_radio_default_setting_field: initialiser le plugin aux paramètres par défaut
   ecet_radio_default_language_field: choix de la langue par défaut pour styliser le bloc gutenberg RSVP
   ecet_text_field: pour le titre de la table des participants
   ecet_select_title_tag_field : pour la balise HTML du titre
   ecet_select_column_field:  pour les nombre de colonne choisis pour la table des participants
   ecet_color_line_field:  couleur de fond des lignes paires
   ecet_select_border_width_field : épaisseur bordure table
   ecet_color_border_field: couleur bordure
   ecet_font_size_field: taille police
   ecet_font_color_field: couleur police
   ecet_rsvp_button_text_field: pour le texte affiché sur le bouton du Block Gutenberg RSVP
   ecet_text_below_number_of_participants_text_field: pour le texte affiché en dessous du nbr de participant sur le block Gutenberg RSVP
   ecet_closed_reservation_text_field: pour le texte affiché RÉSERVATION CLÔTURÉ sur le block Gutenberg RSVP
   ecet_form_reservation_textarea_field: pour le texte affiché en intro du formulaire de réservation
   ecet_event_number_participants_text_field: pour le texte affiché en préfixe du nombre de participants pour le calendrier des évènements en vue liste
	ecet_event_remaining_tickets_text_field: pour le texte affiché en préfixe du nombre de billets restant pour le calendrier des évènements en vue liste
 */
function ecet_easy_custom_event_tickets_activate() {
	
   $settings = array();
   
   $settings  = get_option( 'ecet_multiple_setting' );
   
   // on n'initialise pas le plugin aux valeurs de réglages par défaut 
   // si l'utilisateur a déjà paramétré le plugin
   // cas ou l'utilisateur a désactivé puis réactivé le plugin
   if ( empty( $settings ) ) {
	   
	   // Attention! le champ radio ne prend pas de valeur avec majuscule
	   $settings['ecet_radio_default_setting_field'] = 'no';
	   //$settings['ecet_radio_default_language_field'] ='french';
	   $settings['ecet_text_field'] = 'List of participants';
	   $settings['ecet_select_title_tag_field'] = 'h3';
	   $settings['ecet_select_column_field'] = '4';
	   $settings['ecet_color_line_field'] = '#EFF8FE';
	   $settings['ecet_select_border_width_field'] = '1';
	   $settings['ecet_color_border_field'] = '#e4e4e4';
	   $settings['ecet_select_font_size_field'] = '18';
	   $settings['ecet_font_color_field'] = '#1E2226';
	   $settings['ecet_rsvp_button_text_field'] = 'BOOKING';
	   $settings['ecet_text_below_number_of_participants_text_field'] = 'Booking';
	   $settings['ecet_closed_reservation_text_field'] = 'BOOKING CLOSED';
	   $settings['ecet_form_reservation_textarea_field'] = 'Please submit your BOOKING information, including the total number of guests.';
	   $settings['ecet_event_number_participants_text_field'] = 'number of participants:';
	   $settings['ecet_event_remaining_tickets_text_field'] = 'remaining tickets:';
	   
	   //Paramètres :  option_name , option_value , Description (plus utilisé) , Autoload(charger l'option au démarrage de WordPress)
	   add_option( 'ecet_multiple_setting', $settings, '', 'yes' );
   }
   
}
register_activation_hook( __FILE__, 'ecet_easy_custom_event_tickets_activate' ); 


/*----------------------------------------------------------------------------*
 *          4.1  Actions a réaliser aprés la mise à jour du plugin
 *----------------------------------------------------------------------------*/
 
 
// on utilise le hook  'upgrader_process_complete' qui se déclenche lorsque
// le processus de mise à jour est terminé
// Cette méthode sera appelée lors de l'exécution de la version actuelle de ce plugin, 
// pas de la nouvelle qui vient d'être mise à jour.
// Par exemple: vous exécutez la version 1.0 et venez de passer à la version 2.0. 
// La version 2.0 ne fonctionnera pas encore ici mais la 1.0 fonctionne.
// Donc attention!, aucun code ici ne fonctionnera pour la nouvelle version.  
// Cette action ajoutera une valeur transitoire pour dire que le plugin à été mis à jour
// c'est avec l'action plugins_loaded que l'on va mettre a niveau la base de données du plugin

add_action( 'upgrader_process_complete', 'ecet_upgrade',10, 2);
 
// WP_Upgrader: Classe principale utilisée pour la mise à niveau ou l'installation 
function ecet_upgrade(\WP_Upgrader $upgrader_object, $options ) {
 
   // si le processus en cours est une mise à jour de plugins
   if ( $options['action'] == 'update' && $options['type'] == 'plugin' ) {
	   
       // $options['plugins'] est un tableau des chemins relatif uniquement des plugins mis à jour
	   foreach( $options['plugins'] as  $index => $plugin ) {
		   
          if ( $plugin == ECET_PLUGIN_PATH_NAME ) {
			  
				// ajout d'une valeur transitoire dans la table options
				// pour spécifier que le plugin à été mis à jour
				set_transient('ecet_plugin_updated', 1);
				
				break;
 
          }
		  
       }
	   
	   unset($index, $plugin);  
	 
    }
	
}


// on effectue la mise à niveau de la base de données
// si la valeur transitoire ecet_plugin_updated qui indique qu'une mise a jour
// du plugin a été effectué existe et si l'utilisateur est admin.

add_action('plugins_loaded', 'ecet_updated_plugin');

function ecet_updated_plugin()	{
	
	$settings = array();
	
	// si le plugin à été mis à jour et que l'utilisateur actuel est admin
	if ( get_transient('ecet_plugin_updated') && current_user_can('manage_options') ) {
		
		// on récupère les paramètres de réglages renseignés par l'utilisateur
		// pour la version antérieure du plugin
		 $settings  = get_option( 'ecet_multiple_setting' );

		// On renseigne les paramètres de réglages pour le block Gutenberg RSVP
		// et le calendrier des événements en vue liste 
		// introduit par cette mise à jour à la version 1.8
		$settings['ecet_rsvp_button_text_field'] = 'BOOKING';
	    $settings['ecet_text_below_number_of_participants_text_field'] = 'Booking';
	    $settings['ecet_closed_reservation_text_field'] = 'BOOKING CLOSED';
	    $settings['ecet_form_reservation_textarea_field'] = 'Please submit your BOOKING information, including the total number of guests.';
		$settings['ecet_event_number_participants_text_field'] = 'number of participants:';
	    $settings['ecet_event_remaining_tickets_text_field'] = 'remaining tickets:';
			
		// On met a jour la table option avec notamment ce nouveau réglage
		//Paramètres :  option_name , option_value , Description (plus utilisé) , Autoload(charger l'option au démarrage de WordPress)
		update_option( 'ecet_multiple_setting', $settings, '', 'yes' );
		
		// On supprime la valeur transitoire
		delete_transient('ecet_plugin_updated');
	
	}

}




/*----------------------------------------------------------------------------*
 *                      5. Uninstall Plugin
 *----------------------------------------------------------------------------*/
 
 
 
// a la désinstallation du plugin on supprime les réglages du plugin dans la table wp_options
function ecet_easy_custom_event_tickets_uninstall() {
   delete_option( 'ecet_multiple_setting' ); 
}
register_uninstall_hook( __FILE__, 'ecet_easy_custom_event_tickets_uninstall' );



/*---------------------------------------------------------------------------------------*
 *                  6. chargement feuille de style du plugin
 *--------------------------------------------------------------------------------------*/

// On charge la feuille de style du plugin
// pour bien déclarer le style on utilise le hook: wp_enqueue_scripts
// le tableau array() indique les dépendances autrement dit indiquer à 
// WordPress que notre style devrait absolument être chargé après les styles indiqués en dépendances 
// le numéro de version est important car il va permettre d’invalider le cache du navigateur 
// lorsqu'on fera évoluer le style.
// par défaut le dernier paramètre est à false et le script est chargé dans le head
if ( !function_exists('ecet_chargement_style') ) {
	
	function ecet_chargement_style() {
		
		wp_enqueue_style( 
			'ecet_chargement_style', 
			ECET_EASY_CUSTOM_EVENTS_TICKETS_URL . 'css/easy-custom-event-tickets.css',
			array(), 
			'1.7'
		);
		
		
	}
	
}

add_action( 'wp_enqueue_scripts', 'ecet_chargement_style','15' );



/*----------------------------------------------------------------------------------------------------*
 *   7. Afficher le nom des participants & nbr de réservation par participant aprés le ticket RSVP
 *----------------------------------------------------------------------------------------------------*/
	
	function ecet_afficher_liste_participant_rsvp() {
		
		$participant = array();
		$nom_participant = array();
		$nbr_reservation = array();
		$index = 0;
		$nbr_participant = 0;
		
		// On récupère dans la table wp_options pour le champ option_name = ecet_multiple_setting un tableau qui comporte
		// les valeurs de réglages du plugin renseignés dans les champs correspondants de la page de réglage: ECET Réglages
		// le tableau ayant pour index:
		// ecet_text_field: pour le titre de la table des participants
		// ecet_select_column_field:  pour les nombre de colonne choisis pour la table des participants
		$settings  = get_option( 'ecet_multiple_setting' );
		//print_r($settings); '<br>';
		
		
		// On affiche le titre de la table des participants encadré 
		// par sa balise HTML récupérés en base de données
		// selon les valeurs entrées pour les champs texte & select correspondant 
		// de la page de réglage: ECET Réglages
		if ( !empty( $settings['ecet_text_field'] ) ) {
		
			// si on a renseigné une balise HTML
			if ( !empty( $settings['ecet_select_title_tag_field'] ) ) {
				
				echo '<'.$settings['ecet_select_title_tag_field'].'>'. htmlspecialchars_decode( esc_html__( $settings['ecet_text_field'],'custom-event-tickets' ) ).'</'.$settings['ecet_select_title_tag_field'].'>';
			
			// si on n'a pas renseigné de balise HTML on encadre par défaut le titre par une balise de paragraphe
			}else{
				echo '<p>'.$settings['ecet_text_field'].'</p>';
			}
		}
				
		// ID de l'évènement
		$event_id = get_the_ID();
		
		//la classe wpdb est toujours instanciée au chargement de l’application 
		//et stockée dans une variable globale appelée $wpdb
		global $wpdb;
		
		// permet d'afficher les erreurs
		$wpdb->show_errors();
		
		
		/* ----- ---On récupère les Noms des participants
		         (un participant pouvant acheter plus d'un billet)	--------*/	

		/* $requete="SELECT {$wpdb->prefix}posts.post_title,{$wpdb->prefix}posts.post_date
				  FROM {$wpdb->prefix}posts,{$wpdb->prefix}postmeta 
				  WHERE ({$wpdb->prefix}postmeta.post_id= {$wpdb->prefix}posts.id)
				  AND ({$wpdb->prefix}postmeta.meta_key = '_tribe_rsvp_event' )
				  AND ({$wpdb->prefix}postmeta.meta_value = $event_id )
				  ORDER BY {$wpdb->prefix}posts.post_date DESC , {$wpdb->prefix}posts.post_title DESC
				 ";*/
				 
		//  les méta clés reliant le nom des participants à un événement dans la table postmeta sont:
		// _tribe_rsvp_event pour un billet gratuit ou événement virtuel
		// _tribe_tpp_event dans le cas d'achat de billet
		// le champ meta_value de la table postmeta contient l'ID de l'évènement
		// le post_id de la table postmeta est en relation avec l'id de la table posts
		// ou sont enregitrés les noms des participants dans le champ post_title
		// une valeur de post_title: edaa02c9a886c62668832b9ceaf3cd60 | DUPONT | 1
		$requete = "SELECT {$wpdb->prefix}posts.post_title,{$wpdb->prefix}posts.post_date
				    FROM {$wpdb->prefix}posts,{$wpdb->prefix}postmeta 
				    WHERE {$wpdb->prefix}postmeta.post_id = {$wpdb->prefix}posts.id";
				  
		$requete =  $wpdb->prepare( $requete. " AND {$wpdb->prefix}postmeta.meta_key = %s" , '_tribe_rsvp_event' );		  
				  
		$requete =  $wpdb->prepare( $requete. " AND {$wpdb->prefix}postmeta.meta_value = %d" , $event_id );		  
				   
		$requete = 	$requete. " ORDER BY {$wpdb->prefix}posts.post_date DESC,{$wpdb->prefix}posts.post_title DESC" ; 
				 
				  
		$result = $wpdb->get_results($requete);
		
		// on récupère le nombre d'enregistrement, c'est a dire le nombre de billet achetés
		// mais pas le nombre de participant car plusieurs achats possible de billet par une même personne
		$nbr_enregistrement = $wpdb->num_rows;
		
		// s'il y a des participants et que l'on a renseigné dans la page de réglage du plugin le nbr de colonne
		// pour la table des participants
		if ( $nbr_enregistrement > 0  and ( !empty( $settings['ecet_select_column_field'] ) ) ) {
		    
			// on récupère les lignes brutes des participants au format:
			// soit Mr DUPONT ayant réservé pour 2 participants
			// pour un évènement RSVP:
			// 1ère participant de Dupont: edaa02c9a886c62668832b9ceaf3cd60 | DUPONT | 1	
			// 2ème participant de Dupont: edaa02c9a886c62668832b9ceaf3cd60 | DUPONT | 2	
			// pour un évènement avec billets payant:
			// 1ère participant de Dupont: DUPONT | 1	
			// 2ème participant de Dupont: DUPONT | 2
			foreach ( $result as $row ) {
				$index++;
				$participant[$index] = $row->post_title;
				//echo $participant[$index].'<br>';
			}	
			
			
			
			for ( $nbr=1;$nbr<=$nbr_enregistrement;$nbr++ ) {
			
				
					
				// c'est le type RSVP(billet gratuit) alors on scinde la chaine de caractère
				// en 3 segments et on récupère le nom et le nombre de participant 
				$tab = explode('|',$participant[$nbr],3);
				$participant[$nbr]= $tab[1];
				$nbr_reservation[$nbr]= TRIM($tab[2]);	
					
				
				// on élimine les noms en doublon (plusieurs achat possible de billet par une même personne) 
				// la requête de la base de données ayant été trié dans l'ordre décroissant
				// le 1er nom trouvé dans la table pour une personne qui a acheté plusieurs billets
                // aura pour le champ 'nbr_reservation' le nbr total de réservation
				// array_search Renvoie la clé numérique d'une valeur en l'occurence le nom s'il se trouve dans 
				//la colonne 'nom' du tableau $nom_participant et FALSE dans le cas contraire
				if( array_search( $participant[$nbr], array_column($nom_participant, 'nom') ) === false ) {
						$nbr_participant++;
						$nom_participant[$nbr_participant]['nom'] = $participant[$nbr];
						$nom_participant[$nbr_participant]['nbr_reservation'] = $nbr_reservation[$nbr];
				}
			
			

			}
			
			
			// tri du tableau dans l'ordre croissant selon la colonne 'nom'
			// le tableau est "re-indexé" à partir de 0
			// option: SORT NATURAL pour tenir compte des participants 
			// qui renseigne aussi leur prénom ;
			// option: SORT_FLAG_CASE pour ne pas tenir compte de la casse
			array_multisort( array_column($nom_participant, 'nom'), SORT_ASC, SORT_NATURAL | SORT_FLAG_CASE, $nom_participant );
			//print_r($nom_participant);
			
			$index_liste=0;
			
			// On récupère le nombre de colonne sélectionnée dans la page de réglages du plugin
			$nbr_col = intval( $settings['ecet_select_column_field'] );
						
			// nbr de ligne du tableau arrondi à l'entier supérieur
			$nbr_ligne_tab = ceil($nbr_participant/$nbr_col);
			
			
			// Affichage de la table des participants
			echo '<table class="table-participant">';
			
			/*----------------------------------------------------------------------------------------------------*
			*   7.1 CSS dynamique de la table des participants & du block Gutenberg RSVP
			*----------------------------------------------------------------------------------------------------*/
			
			echo'<style>';
			
			/*--------------- CSS Table des participants ------------------*/
			
			echo'.table-participant td {';
			echo'border-width:'.$settings['ecet_select_border_width_field'].'px;';
			echo'border-color:' .$settings['ecet_color_border_field'].';';
			echo'font-size:'.$settings['ecet_select_font_size_field'].'px;';
			echo'color:'.$settings['ecet_font_color_field'].';';
			echo'}';
			
            echo'.table-participant tbody > tr:nth-child(2n) td {';
			echo'background:'.$settings['ecet_color_line_field'].';';
			echo'}';
			
			/*----------- CSS Block Gutenberg RSVP ------------------*/
			
			// On remplace le titre du bouton GOING par BOOKING et on décode a l'affichage l'échappement des caractères spéciaux excepté les ""
			echo'.event-tickets .tribe-tickets__rsvp-actions .tribe-common-c-btn:after {';
			echo'content:"' . htmlspecialchars_decode( esc_html__( $settings['ecet_rsvp_button_text_field'],'custom-event-tickets' ) ) . '";';
	        echo'}';
			
			// pour le nombre de participants On remplace le texte Going par Booking 
			echo'.event-tickets .tribe-tickets__rsvp-attendance-going:after {';
			echo'content:"' . htmlspecialchars_decode( esc_html__( $settings['ecet_text_below_number_of_participants_text_field'],'custom-event-tickets' ) ) . '";';
	        echo'}';
				
			//on remplace le texte RSVP CLOSED par BOOKING CLOSED
			echo'.event-tickets .tribe-tickets__rsvp-actions-full-text:after {';
			echo'content:"' . htmlspecialchars_decode( esc_html__( $settings['ecet_closed_reservation_text_field'],'custom-event-tickets' ) ) . '";';
	        echo'}';
			
			//On remplace le texte en intro du formulaire de Réservation et on décode a l'affichage l'échappement des caractères spéciaux excepté les ""
			echo'.event-tickets .tribe-tickets__rsvp-form-title h3:after {';
			echo'content:"' . htmlspecialchars_decode( __( $settings['ecet_form_reservation_textarea_field'],'custom-event-tickets' ) ). '";';
	        echo'}';
			
			echo'</style>';
			
			echo'<tbody>';
			
			for ( $index_ligne=1;$index_ligne<=$nbr_ligne_tab;$index_ligne++ ) { 
			
				echo '<tr>';
				
					for ( $index_colonne=1;$index_colonne<=$nbr_col ;$index_colonne++ ) {
						
						echo '<td>'				
						.$nom_participant[$index_liste]['nom']
						.' ('.$nom_participant[$index_liste]['nbr_reservation'].')'
						.'</td>';
						
						$index_liste++ ; 
						
						// l'affichage de la table est terminée si la condition est vrai
						if ( $index_liste > $nbr_participant - 1 ){
							$index_colonne = $nbr_col + 1;
						} 
						
					}
				
				echo '</tr>';
			}
			
			echo'</tbody>';
			echo '</table>';
		

		}
		
	}
	
	add_action( 'tribe_template_after_include:tickets/v2/rsvp', 'ecet_afficher_liste_participant_rsvp',10,3 );
	

/*--------------------------------------------------------------------------------------------------*
 *    8. Afficher le nom des participants & nbr de réservation par participant aprés le bloc Tickets
 *--------------------------------------------------------------------------------------------------*/
	
	function ecet_afficher_liste_participant() {
		
		$participant = array();
		$nom_participant = array();
		$nbr_reservation = array();
		$index = 0;
		$nbr_participant = 0;
		
		
		// On récupère dans la table wp_options  pour le champ option_name = ecet_multiple_setting 
		// les valeurs de réglages du plugin renseignés dans les champs correspondants de la page de réglage: ECET Réglages
		// ecet_text_field: pour le titre de la table des participants
		// ecet_select_column_field:  pour les nombre de colonne choisis pour la table
		$settings  = get_option( 'ecet_multiple_setting' );
		//print_r($settings);
		
		
		// On affiche le titre de la table des participants encadré 
		// par sa balise HTML récupérés en base de données
		// selon les valeurs entrées pour les champs texte & select correspondant 
		// de la page de réglage: ECET Réglages
		if ( !empty( $settings['ecet_text_field'] ) ) {
		
			// si on a renseigné une balise HTML
			if ( !empty( $settings['ecet_select_title_tag_field'] ) ) {
				
				echo '<'.$settings['ecet_select_title_tag_field'].'>'.htmlspecialchars_decode( esc_html__( $settings['ecet_text_field'],'custom-event-tickets' ) ).'</'.$settings['ecet_select_title_tag_field'].'>';
			
			// si on n'a pas renseigné de balise HTML on encadre par défaut le titre par une balise de paragraphe
			}else{
				echo '<p>'.$settings['ecet_text_field'].'</p>';
			}
		}
		
				
		// ID de l'évènement
		$event_id = get_the_ID();
		
		//la classe wpdb est toujours instanciée au chargement de l’application 
		//et stockée dans une variable globale appelée $wpdb
		global $wpdb;
		
		// permet d'afficher les erreurs
		$wpdb->show_errors();
		
		
		/* ----- ---On récupère les Noms des participants
		         (un participant pouvant acheter plus d'un billet)	--------*/	

		/* $requete="SELECT {$wpdb->prefix}posts.post_title,{$wpdb->prefix}posts.post_date
				  FROM {$wpdb->prefix}posts,{$wpdb->prefix}postmeta 
				  WHERE ({$wpdb->prefix}postmeta.post_id= {$wpdb->prefix}posts.id)
				  AND ({$wpdb->prefix}postmeta.meta_key = '_tribe_tpp_event' )
				  AND ({$wpdb->prefix}postmeta.meta_value = $event_id )
				  ORDER BY {$wpdb->prefix}posts.post_date DESC , {$wpdb->prefix}posts.post_title DESC
				 ";*/
				 
		//  les méta clés reliant le nom des participants à un événement dans la table postmeta sont:
		// _tribe_rsvp_event pour un billet gratuit ou événement virtuel
		// _tribe_tpp_event dans le cas d'achat de billet
		// le champ meta_value de la table postmeta contient l'ID de l'évènement
		// le post_id de la table postmeta est en relation avec l'id de la table posts
		// ou sont enregitrés les noms des participants dans le champ post_title
		// une valeur de post_title: DUPONT | 1
		$requete = "SELECT {$wpdb->prefix}posts.post_title,{$wpdb->prefix}posts.post_date
				    FROM {$wpdb->prefix}posts,{$wpdb->prefix}postmeta 
				    WHERE {$wpdb->prefix}postmeta.post_id = {$wpdb->prefix}posts.id";
				  
		$requete =  $wpdb->prepare( $requete. " AND {$wpdb->prefix}postmeta.meta_key = %s" , '_tribe_tpp_event' );		  
				  
		$requete =  $wpdb->prepare( $requete. " AND {$wpdb->prefix}postmeta.meta_value = %d" , $event_id );		  
				   
		$requete = 	$requete. " ORDER BY {$wpdb->prefix}posts.post_date DESC,{$wpdb->prefix}posts.post_title DESC" ; 
				 
				  
		$result = $wpdb->get_results($requete);
		
		// on récupère le nombre d'enregistrement, c'est a dire le nombre de billet achetés
		// mais pas le nombre de participant car plusieurs achats possible de billet par une même personne
		$nbr_enregistrement = $wpdb->num_rows;
				
				
		// s'il y a des participants et que l'on a renseigné dans la page de réglage du plugin le nbr de colonne
		// pour la table des participants
		if ( $nbr_enregistrement > 0  and ( !empty( $settings['ecet_select_column_field'] ) ) ) {
		
			// on récupère les lignes brutes des participants au format:
			// soit Mr DUPONT ayant réservé pour 2 participants
			// pour un évènement avec billets payant:
			// 1ère participant de Dupont: DUPONT | 1	
			// 2ème participant de Dupont: DUPONT | 2
			foreach ( $result as $row ) {
				$index++;
				$participant[$index] = $row->post_title;
				//echo $participant[$index].'<br>';
			}	
			
			
			
			for ( $nbr=1;$nbr<=$nbr_enregistrement;$nbr++ ) {
			
				
					
				// c'est le type Tickets(billet payant) alors on scinde la chaine de caractère 
				// en 2 segments et on récupère le nom et le nombre de participant 
				$tab = explode('|',$participant[$nbr],2);
				$participant[$nbr]= $tab[0];
				$nbr_reservation[$nbr]= TRIM($tab[1]);	
				
			
				// on élimine les noms en doublon (plusieurs achat possible de billet par une même personne) 
				// la requête de la base de données ayant été trié dans l'ordre décroissant
				// le 1er nom trouvé dans la table pour une personne qui a acheté plusieurs billets
                // aura pour le champ 'nbr_reservation' le nbr total de réservation
				// array_search Renvoie la clé numérique d'une valeur en l'occurence le nom s'il se trouve dans 
				//la colonne 'nom' du tableau $nom_participant et FALSE dans le cas contraire
				if( array_search( $participant[$nbr], array_column($nom_participant, 'nom') ) === false ) {
						$nbr_participant++;
						$nom_participant[$nbr_participant]['nom'] = $participant[$nbr];
						$nom_participant[$nbr_participant]['nbr_reservation'] = $nbr_reservation[$nbr];
				}
			
			

			}
			
			
			// tri du tableau dans l'ordre croissant selon la colonne 'nom'
			// le tableau est "re-indexé" à partir de 0
			// option: SORT NATURAL pour tenir compte des participants 
			// qui renseigne aussi leur prénom ;
			// option: SORT_FLAG_CASE pour ne pas tenir compte de la casse
			array_multisort( array_column($nom_participant, 'nom'), SORT_ASC, SORT_NATURAL | SORT_FLAG_CASE, $nom_participant );
			//print_r($nom_participant);
			
			$index_liste=0;
				
			// On récupère le nombre de colonne sélectionnée dans la page de réglages du plugin
			$nbr_col = intval( $settings['ecet_select_column_field'] );
			
			// nbr de ligne du tableau arrondi à l'entier supérieur
			$nbr_ligne_tab = ceil($nbr_participant/$nbr_col);
			
			
			// Affichage de la table des participants
			echo '<table class="table-participant">';
			
			
			/*----------------------------------------------------------------------------------------------------*
			*   8.1 CSS dynamique de la table des participants pour des billets payants
			*----------------------------------------------------------------------------------------------------*/
			
			echo'<style>';
			
			echo'.table-participant td {';
			echo'border-width:'.$settings['ecet_select_border_width_field'].'px;';
			echo'border-color:' .$settings['ecet_color_border_field'].';';
			echo'font-size:'.$settings['ecet_select_font_size_field'].'px;';
			echo'color:'.$settings['ecet_font_color_field'].';';
			echo'}';
			
            echo'.table-participant tbody > tr:nth-child(2n) td {';
			echo'background:'.$settings['ecet_color_line_field'].';';
			echo'}';
			
			echo'</style>';
			
			echo'<tbody>';
			
			for ( $index_ligne=1;$index_ligne<=$nbr_ligne_tab;$index_ligne++ ) { 
			
				echo '<tr>';
				
					for ( $index_colonne=1;$index_colonne<=$nbr_col ;$index_colonne++ ) {
						
						echo '<td>'
						.$nom_participant[$index_liste]['nom']
						.' ('.$nom_participant[$index_liste]['nbr_reservation'].')'
						.'</td>';
						
						$index_liste++ ; 
						
						// l'affichage de la table est terminée si la condition est vrai
						if ( $index_liste > $nbr_participant - 1 ){
							$index_colonne = $nbr_col + 1;
						} 
						
					}
				
				echo '</tr>';
			}
			
			echo'</tbody>';
			echo '</table>';
		

		}
		
	}

	add_action( 'tribe_template_after_include:tickets/blocks/tickets', 'ecet_afficher_liste_participant',10,3 );
	
	//add_action( 'tribe_template_after_include:events/v2/list/event/description', 'ecet_afficher_liste_participant',10,3 );
	
	
/*--------------------------------------------------------------------------------------------------------------------------------*
 *  9. Afficher sur le calendrier des évènements en vue Liste le nbr de participant & nbr de billet restant pour des billets RSVP
 *--------------------------------------------------------------------------------------------------------------------------------*/
	
	function ecet_nbr_participant_rsvp() {
		
		// ID de l'évènement
		$event_id = get_the_ID() ;
		
		//la classe wpdb est toujours instanciée au chargement de l’application 
		//et stockée dans une variable globale appelée $wpdb
		global $wpdb;
		
		// permet d'afficher les erreurs
		$wpdb->show_errors();
		
		
		/* --------- on récupère l'ID du ticket en correspondance avec l'ID de l'événement --------*/	
		
		/*$requete = "SELECT post_id 
					 FROM {$wpdb->prefix}postmeta
					 WHERE (meta_value = $event_id  
					 AND meta_key = '_tribe_rsvp_for_event' ";*/
		
		// pour l'ID les méta clés reliant un ticket à un événement sont:
		// _tribe_rsvp_for_event pour un billet gratuit ou événement virtuel
		// _tribe_tpp_for_event dans le cas d'achat de billet
		$requete = $wpdb->prepare( "SELECT post_id 
									FROM {$wpdb->prefix}postmeta
									WHERE meta_value = %d " , $event_id  );
						
		$requete = $wpdb->prepare( $requete. " AND meta_key = %s" , '_tribe_rsvp_for_event'  );			
						
		$ticket_id  = $wpdb->get_var($requete);
		
		// on sort si on n'a pas crée de billet pour l'événement en cours
		if ( empty( $ticket_id ) ) {
		return;
		}
		
		// Nombre de participant
		$nbr_participant = get_post_meta( $ticket_id, 'total_sales', true );
		
	    // Nombre de billet restant 
		$nbr_billet = get_post_meta( $ticket_id, '_stock', true );		

		// on récupère les paramètres de la page de réglages
		$settings  = get_option( 'ecet_multiple_setting' );		
			
		// autre classe possible: tribe-common-b2 pour une police de 14px		
		echo '<span class="tribe-common-h7">' . esc_html__( $settings['ecet_event_number_participants_text_field'],'custom-event-tickets' ) . ' ' . $nbr_participant . '</span><br>';
		echo '<span class="tribe-common-h7">' . esc_html__( $settings['ecet_event_remaining_tickets_text_field'],'custom-event-tickets' ) . ' ' . $nbr_billet . '</span>';
		
	}
	
	add_action( 'tribe_template_after_include:events/v2/list/event/description', 'ecet_nbr_participant_rsvp',10,3 );
	
	
/*---------------------------------------------------------------------------------------------------------------------------------------------------*
 *    10. Afficher sur le calendrier des évènements en vue Liste le nbr de participant & nbr de billet restant pour des billets payants
 *---------------------------------------------------------------------------------------------------------------------------------------------------*/	
		
	function ecet_nbr_participant() {
		
		// ID de l'évènement
		$event_id = get_the_ID() ;
		
		//la classe wpdb est toujours instanciée au chargement de l’application 
		//et stockée dans une variable globale appelée $wpdb
		global $wpdb;
		
		// permet d'afficher les erreurs
		$wpdb->show_errors();
		
		
		/* --------- on récupère l'ID du ticket en correspondance avec l'ID de l'événement --------*/	
		
		/*$requete = "SELECT post_id 
					  FROM {$wpdb->prefix}postmeta
					  WHERE (meta_value = $event_id  
					  AND meta_key = '_tribe_tpp_for_event' ";*/
		
		// pour l'ID les méta clés reliant un ticket à un événement sont:
		// _tribe_rsvp_for_event pour un billet gratuit ou événement virtuel
		// _tribe_tpp_for_event dans le cas d'achat de billet
		$requete = $wpdb->prepare( "SELECT post_id , meta_key
									FROM {$wpdb->prefix}postmeta
									WHERE meta_value = %d " , $event_id  );
						
		$requete = $wpdb->prepare( $requete. " AND meta_key = %s" , '_tribe_tpp_for_event' );			
						
					
		$ticket_id = $wpdb->get_var($requete);
		
		// on sort si on n'a pas crée de billet pour l'événement en cours
		if ( empty( $ticket_id ) ) {
		return;
		}
		
		// Nombre de participant
		$nbr_participant = intval( get_post_meta( $ticket_id, 'total_sales', true ) );
		
		$nbr_billet_a_vendre = intval( get_post_meta( $ticket_id, '_tribe_ticket_capacity', true ) );
	    // Nombre de billet restant 
		$nbr_billet = $nbr_billet_a_vendre - $nbr_participant;	

		// on récupère les paramètres de la page de réglages
		$settings  = get_option( 'ecet_multiple_setting' );		
			
		// autre classe possible: tribe-common-b2 pour une police de 14px		
		echo '<span class="tribe-common-h7">' . esc_html__( $settings['ecet_event_number_participants_text_field'],'custom-event-tickets' ) . ' ' . $nbr_participant . '</span><br>';
		echo '<span class="tribe-common-h7">' . esc_html__( $settings['ecet_event_remaining_tickets_text_field'],'custom-event-tickets' ) . ' ' . $nbr_billet . '</span>';
		
	}
	
	add_action( 'tribe_template_after_include:events/v2/list/event/description', 'ecet_nbr_participant',10,3 );
